<!DOCTYPE html>
<html lang="en" xmlns:th="http://www.thymeleaf.org"
      xmlns:layout="http://www.ultraq.net.nz/thymeleaf/layout"
      xmlns:sec="http://www.thymeleaf.org/extras/spring-security"
      layout:decorate="~{layoutadmin}">
<head>
    <meta charset="UTF-8">
    <title>Presensi</title>
    <link rel="stylesheet" th:href="@{/style.css}">
</head>
<body>
<div layout:fragment="main">
    <div class="header bg-gradient-primary pb-8 pt-5 pt-md-8">
        <div class="container-fluid">
            <div class="header-body">
                <!-- Card stats -->
                <div class="row">
                    <div class="col-xl-12 col-lg-12">
                        <div class="card card-stats mb-4 mb-xl-0">
                            <div class="card-body">
                                <div class="row">
                                    <div class="col">
                                        <h5 class="card-title text-uppercase text-muted mb-0">Edit</h5>
                                        <span class="h2 font-weight-bold mb-0">Presensi</span>
                                    </div>
                                    <div class="col-auto">
                                        <div class="icon icon-shape bg-gradient-blue text-white rounded-circle shadow">
                                            <i class="fas fa-user-astronaut"></i>
                                        </div>
                                    </div>
                                </div>

                            </div>
                        </div>
                    </div>

                </div>
            </div>
        </div>
    </div>

    <div class="container-fluid mt--7">
        <!-- Table -->
        <div class="row">
            <div class="col">
                <div class="card shadow">
                    <div class="card-header border-0">
                        <div class="row align-items-center">
                            <div class="col">
                                <h3 class="mb-0">
                                    <form th:action="@{/studiesActivity/attendance/save (sesi= ${sesi})}" method="post" id="formAll">
                                        <b> Set Semua Mahasiswa : </b>
                                        <select name="statusPresensi">
                                            <option value="MANGKIR">Mangkir</option>
                                            <option value="HADIR">Hadir</option>
                                            <option value="IZIN">Izin</option>
                                            <option value="SAKIT">Sakit</option>
                                        </select>
                                        <button class="btn btn-success btn-sm" type="button" id="btnAll" onclick="saveALl()">Set Status</button>
                                    </form>
                                </h3>
                            </div>
                            <div class="col text-right">
                                <a th:href="@{/studiesActivity/attendance/detail (jadwal = ${jadwal})}" class="btn btn-sm btn-default">
                                    <i class="fas fa-arrow-alt-circle-left"></i> Kembali</a>
                            </div>
                        </div>
                    </div>
                    <div class="card-body">
                        <form method="post" class="needs-validation" novalidate="">
                            <div class="card-header">
                                <h4 id="h4-header-pres"></h4>
                            </div>
                            <input type="hidden" id="idSesiKuliah" th:value="${sesi}">
                            <div class="card-body">
                                <div class="table table-striped">
                                    <table
                                            id="tableMahasiswa"
                                            data-filter-control="true"
                                            data-search="true"
                                            data-show-refresh="true"
                                            data-flat="true"
                                            data-pagination="true"
                                            th:attr="data-url=@{/detail-presensi-mahasiswa(id=${sesi})}"
                                            data-side-pagination="client">
                                    </table>
                                </div>
                            </div>

                        </form>
                    </div>


                </div>
            </div>
        </div>

    </div>

</div>
</body>
</html>
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/izitoast/1.4.0/css/iziToast.min.css"
      integrity="sha512-O03ntXoVqaGUTAeAmvQ2YSzkCvclZEcPQu1eqloPaHfJ5RuNGiS4l+3duaidD801P50J28EHyonCV06CUlTSag=="
      crossorigin="anonymous" referrerpolicy="no-referrer"/>
<script src="https://cdnjs.cloudflare.com/ajax/libs/izitoast/1.4.0/js/iziToast.min.js"
        integrity="sha512-Zq9o+E00xhhR/7vJ49mxFNJ0KQw1E1TMWkPTxrWcnpfEFDEXgUiwJHIKit93EW/XxE31HSI5GEOW06G6BF1AtA=="
        crossorigin="anonymous" referrerpolicy="no-referrer"></script>
<link href="https://unpkg.com/bootstrap-table@1.18.3/dist/bootstrap-table.min.css" rel="stylesheet">
<script src="//cdn.jsdelivr.net/npm/sweetalert2@11"></script>
<script src="https://unpkg.com/bootstrap-table@1.18.3/dist/bootstrap-table.min.js"></script>
<script src="https://unpkg.com/bootstrap-table@1.18.3/dist/extensions/filter-control/bootstrap-table-filter-control.min.js"></script>
<script src="https://unpkg.com/bootstrap-table@1.18.3/dist/extensions/auto-refresh/bootstrap-table-auto-refresh.min.js"></script>
<script>
    $(function () {
        const url = '/detail-presensi-mahasiswa?id=' + $('#idSesiKuliah').val();
        $.getJSON(url, function (data) {
            $.each(data, function (key, entry) {
                $('#absen-' + entry.idPresensi).val(entry.presensi);
            });
        });

        iziToast.settings({
            timeout: 3000, // default timeout
            resetOnHover: true,
            transitionIn: 'flipInX',
            transitionOut: 'flipOutX',
            position: 'topRight', // bottomRight, bottomLeft, topRight, topLeft, topCenter, bottomCenter, center
        });

        $('#tableMahasiswa').bootstrapTable({
            pageSize: 40,
            columns: [{
                field: 'nim',
                title: 'Mahasiswa',
                sortable: true,
                align: 'center',
                valign: 'middle',
                formatter: nimFormatter
            }, {
                title: 'Waktu',
                field: 'time',
                align: 'center',
                valign: 'middle',
                width: '200',
                sortable: true
            }, {
                title: 'Status',
                field: 'presensi',
                align: 'center',
                valign: 'middle',
                width: '200',
                height: '100',
                formatter: absenFormatter
            }]
        });

        function nimFormatter(value, row) {
            return row.nim + ' - ' + row.nama;
        }

        function absenFormatter(value, row) {
            // Daftar opsi untuk select
            const options = [
                { value: 'UNKNOWN', text: '----' },
                { value: 'MANGKIR', text: 'Mangkir' },
                { value: 'HADIR', text: 'Hadir' },
                { value: 'IZIN', text: 'Izin' },
                { value: 'SAKIT', text: 'Sakit' }
            ];

            let optionsHtml = options.map(option => {
                const selected = option.value === row.presensi ? ' selected' : '';
                return `<option value="${option.value}"${selected}>${option.text}</option>`;
            }).join('');

            return `<select id="absen-${row.idMahasiswa}" onchange="editPresensi(this.id, '${row.idSesi}')" class="form-control input-sm">
                ${optionsHtml}
            </select>`;
        }

        window.editPresensi = function (id, sesi) {
            const selectElement = $('#' + id);
            const selectedValue = selectElement.val();
            const originalHtml = selectElement.prop('outerHTML');

            const loadingButton = $('<button class="btn btn-sm btn-warning" type="button" disabled><span class="spinner-border spinner-border-sm" role="status" aria-hidden="true"></span> Sedang Proses</button>');
            selectElement.hide();
            selectElement.after(loadingButton);
            var token = $("input[name='_csrf']").val();
            $.ajax({
                type: "POST",
                contentType: "application/json",
                headers: {"X-CSRF-TOKEN": token},
                url: "/update-presensi-mahasiswa/" + id.slice(6) + "?status=" + $('#' + id).val() + "&sesi="+ sesi,
                dataType: 'json',
                cache: false,
                timeout: 600000,
                success: function (result) {
                    iziToast.success({title: 'Data Terupdate', message: result.message});
                    loadingButton.remove();
                    selectElement.show();
                },
                error: function (xhr, status, error) {
                    iziToast.error({title: 'Error', message: 'Terjadi kesalahan. Silakan coba lagi.'});
                }
            });
        };

    });

    function saveALl(){
        $("#btnAll").removeClass("btn-primary");
        $("#btnAll").addClass("btn-warning");
        $("#btnAll").prop("disabled", true);
        $("#btnAll").html("Loading...");

        $("#formAll").submit();
    }
</script>